#!/usr/local/bin/perl
#
# $Id: bbnet-larrd.pl,v 1.12 2004/02/24 20:30:12 cncook Exp $
#
# bbnet-larrd.pl - larrd module for collecting tcp
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#  
# Christian Pearce
# pearcec@PacketPushers.com
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# 31 Jan 2003   Craig Cook
# Made fping graph work if you set the column header to "conn"

# 13 Mar 2003   Craig Cook
# created @tcp_array
# created @ds
# changed $tcp to $ds
# added patch from James Overbeck for fping
# added comment for James' patch
#
# 27 Jun 2003   Craig Cook
# Changed status check to look for colour status only at start of line
#
# 14 Feb 2005   Craig Cook
# Removed http/url checks - they now live in WebApp.pl
# Now uses LARRD.pm
#
# 22 Mar 2005   Craig Cook
# Applied patch from Richard Finegold
# - fping now allows for 100+ ms responses


@tcp_array = ("conn","fping","ssh","telnet","nntp","ftp","pop","pop-2","pop2","pop-3","pop3","smtp","imap2","imap","ldap");

my @ds = ("DS:sec:GAUGE:600:0:U",
         );

my $reference_to_rrd_data_structure = \@ds;

my $WARN = 1 if $ENV{'WARN'};
my $DEBUG = 0;
$DEBUG = 1 if $ENV{'DEBUG'};

if ($DEBUG) {
  $WARN = 1;
  $ENV{'BBHOME'}="/usr/local/bb";
  $ENV{'BBVAR'}="/usr/local/bbvar";
  $ENV{'BBLOGS'}="/usr/local/bbvar/logs";
  $ENV{'BBRRDS'}="$ENV{'BBVAR'}/rrd";
  use lib "/usr/local/rrdtool/lib/perl/";
  use lib "/usr/local/larrd/lib/LARRD";
}


use lib $ENV{'RRDPM'};
use RRDs;

use lib $ENV{'LARRDPM'};
use LARRD;

my $larrd = new LARRD;

##################################
# Start of script
##################################

$larrd->check_larrd_env;

##
# real work begins here
##

$filenames_ref = $larrd->get_bb_log_filenames($DEBUG);

foreach my $ds (@tcp_array) { 

  print "$0: DEBUG in foreach - ds: $ds\n" if ($DEBUG);

  my $host = "";
  my $log_filename = "";
  my $hash_ref_for_hosts = undef;

  $hash_ref_for_hosts = $larrd->read_bb_logs($DEBUG,$ds,$filenames_ref);

  while ( ($host,$log_filename) = each %$hash_ref_for_hosts ) {

	$RRD="$ENV{'BBRRDS'}/$host.tcp.$ds.rrd";	

        print "$0: DEBUG RRD: $RRD\n" if ($DEBUG);

        $log_time = $larrd->get_log_time($DEBUG,$log_filename);

        $reference_to_log_data = $larrd->get_info_from_log($DEBUG,$log_filename);

        if($$reference_to_log_data[0] !~ /^(green|yellow|red)\s+/) {
                print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($WARN);
                next; #next LOG;
        }

        my $data_value = &process_log($DEBUG,$ds,$reference_to_log_data);

        # 4. create the rrd filename

        if ($data_value ne "") {

           # If we are looking at a log with no larrdable data
           # do not create the rrd and in turn the graph
           # It makes sense this way.

           $larrd->update_rrd($DEBUG,$RRD,$log_time,$data_value,$reference_to_rrd_data_structure);

        } # end if ($data_value ne "") {

  }
}

sub process_log ($$$) {
  my ($DEBUG, $ds, $reference_to_log_data) = @_;

        foreach $line (@$reference_to_log_data) {

          next if $line =~ /^$/;

            print "$0: DEBUG ds: $ds, line: $line\n" if ($DEBUG);

            if ( ($line =~ /Seconds/) && ($ds ne "conn") ) {
                        ($dummy,$sec) = split " ",$line,3;
                         print "$0: DEBUG found Seconds sec: $sec\n" if ($DEBUG);
                         last;

            } elsif ( ($line =~ /time=/) && ($ds eq "conn") ) {

                        # is this the best method for finding ping conn

                        ($dummy,$total_time) = split "time=",$line;
                        ($sec,$dummy) = split " ",$total_time;
                         $sec=$sec/1000; # convert milliseconds to seconds

                        if($dummy =~ /^usec/) {
                                $sec=$sec/1000;
                        } elsif ($dummy =~ /^sec/) {
                                $sec=$sec*1000;
                        }
                        print "$0: DEBUG found time= sec: $sec \n" if ($DEBUG);

            } elsif (  # are we using fping?
                        ($line =~ /alive\s+\((\d+\.?\d+)\s+ms\)/) && ( ($ds eq "conn") or ($ds eq "fping") ) ) {
                         $sec = $1 / 1000;
                         print "$0: DEBUG using fping sec: $sec \n" if ($DEBUG);
            }
        }

        print "$0: DEBUG sec: $sec\n" if ($DEBUG);

        return ($sec);
}

##############################################
# end of script
##############################################
