#!/usr/local/bin/perl
#
# $Id: temperature-larrd.pl,v 1.2 2003/03/18 21:55:16 cncook Exp $
#
# temperature-larrd.pl: larrd module to report temperature stats
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#  
# Christian Pearce
# pearcec@PacketPushers.com
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

my $DEBUG = 0;
$DEBUG = 1 if $ENV{'DEBUG'};

if ($DEBUG) {
  $WARN = 1;
  use Data::Dumper;
  $ENV{'BBHOME'}="/usr/local/bb";
  $ENV{'BBVAR'}="/usr/local/bbvar";
  $ENV{'BBLOGS'}="/usr/local/bbvar/logs";
  $ENV{'BBRRDS'}="$ENV{'BBVAR'}/rrd";
  use lib "/usr/local/rrdtool/lib/perl/";
  use lib "/usr/local/larrd/lib/LARRD";
}


# Set a path to the rrd tool lib
# Set as and $ENV and see what is up
use lib $ENV{'RRDPM'};
use RRDs;

use lib $ENV{'LARRDPM'};
use LARRD;

my $larrd = new LARRD;

my $ds = "temperature";
my @ds = ("DS:temperature:GAUGE:600:1:U");

my $reference_to_rrd_data_structure = \@ds;
my $RRD;


##################################
# Start of script
##################################

$larrd->check_larrd_env;

##
# real work begins here
##

$filenames_ref = $larrd->get_bb_log_filenames($DEBUG);

$hash_ref_for_hosts = $larrd->read_bb_logs($DEBUG,$ds,$filenames_ref);

while ( ($host,$log_filename) = each %$hash_ref_for_hosts ) {

    print "$0 : DEBUG host=$host, log=$log_filename\n" if ($DEBUG);

    $log_time = $larrd->get_log_time($DEBUG,$log_filename);

    $reference_to_log_data = $larrd->get_info_from_log($DEBUG,$log_filename);

    if($$reference_to_log_data[0] !~ /^(green|yellow|red)\s+/) {
            print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($WARN);
            next;
    }

    # Now lets process the data

    my ($RRD,$data_value) = &process_log($DEBUG,$ds,$host,$reference_to_log_data);



}


sub process_log ($$$$) {
my ($DEBUG, $ds, $host, $log_data_ref) = @_;
my $RRD;

  foreach $line (@$log_data_ref) {

    print "$0: DEBUG line: $line\n" if $DEBUG;

    #Expect data like this:
    # Device             Temp(C)  Temp(F)
    # -----------------------------------
    # &green CPU         45       113
    # &green AMBIENT     35       95 

    # Or this:

    #Device          Temp(C)  Temp(F)  Threshold(C)";
    #----------------------------------------------";
    # &green Temperature       45       113     55


	# Change / to , and single spaces to _
	$line =~ s/\//,/g;
	$line =~ s/(\S) (\S)/$1_$2/g;
	# Do space check again in case of "X Y Z" matches
	$line =~ s/(\S) (\S)/$1_$2/g;
	# Removed any HTML tags
	$line =~ s/<.*>//g;
	$line =~ s/\&red_*//g;
	$line =~ s/\&yellow_*//g;
	$line =~ s/\&green_*//g;

	print "$0: DEBUG $line\n" if $DEBUG;

	@col = split " ",$line;

	# Throw away lines that are not data
	next if ($col[1] !~ /\d+/);
	next if ($col[2] !~ /\d+/);
	next if ($line =~ /Temp(F)/);
	next if ($col[0] =~ /^green|^yellow|^red|^purple|^clear|^blue/);
	next if ($col[0] =~ /\d+.\d+_C/);

        $data_value = $col[1];

        my $RRD="$ENV{'BBRRDS'}/$host.$ds,$col[0].rrd";

    #    return ($RRD,$data_value);
        if ($data_value ne "") {

           # If we are looking at a log with no larrdable data
           # do not create the rrd and in turn the graph
           # It makes sense this way.

           $larrd->update_rrd($DEBUG,$RRD,$log_time,$data_value,$reference_to_rrd_data_structure);

        } # end if ($data_value ne "") {

  }
}

##############################################
# end of script
##############################################
